import * as t from 'drizzle-orm/pg-core';
import { timestamps } from '../util';
import { competitions } from './competitions';
import { relations } from 'drizzle-orm';

export const schedulingModes = t.pgTable('scheduling_modes', {
	id: t.serial('id').primaryKey(),
	competition_id: t.integer('competition_id').notNull(),
	name: t.text('name').notNull(),
	description: t.text('description'),
	algorithm: t.text('algorithm').notNull(),
	config: t.jsonb('config').notNull(),
	sequence_order: t.integer('sequence_order').notNull(),
	status: t.text('status').notNull(),
	...timestamps
});

export const schedulingModesRelations = relations(schedulingModes, ({ one }) => ({
	competition: one(competitions, {
		fields: [schedulingModes.competition_id],
		references: [competitions.id]
	})
}));

export type SchedulingMode = typeof schedulingModes.$inferSelect;
